/*----------------------------------------------------------
* Copyright (c) 2002 by National Semiconductor Corporation
* All rights reserved.
*-----------------------------------------------------------
* File Contents:
*     smb.h
* Project: IMB Driver 
*---------------------------------------------------------*/
/*
 * $Log:   //epg-scc/sst/ProjectDatabases/ISM/archives/ISM8x/v80/PI/Windows/imbdrv/smb.h.v  $
 * 
 *    Rev 1.0   May 13 2004 14:14:14   jggoodno
 * Initial revision.
 * 
 *    Rev 1.0   14 Oct 2003 06:32:06   sgangadx
 * Initial revision.
 * Revision 1.2  2003/03/23 04:50:40Z  marcela
 * Add amd functions
 * Revision 1.1  2002/12/11 07:24:38Z  mks
 * Initial revision
 */

#define SMB_DATA_ADDRESS = 0x000

// Wipro for Merging April 04
#define DEFAULT_IMB_BASE   0xcaa // This Parameter is Redundant : just kept to maintain 
	                             // structure format, Shouldn't be used anywhere

//
// Default SMS and SMM interface addresses
//
#define ISA_SMS_DATA          0xCA2
#define ISA_SMS_CMD_STATUS    0xCA3

#define ISA_SMM_DATA          0xCA4
#define ISA_SMM_CMD_STATUS    0xCA5
//
// State bits based on S1 & S0 below
//
#define ISA_STATE_MASK        0xC0
#define ISA_IDLE_STATE        0x00
#define ISA_READ_STATE        0x40
#define ISA_WRITE_STATE       0x80
#define ISA_ERROR_STATE       0xC0
//
// Status Register Bits
//
#define ISA_S1_FLAG           0x80
#define ISA_S0_FLAG           0x40
// RESERVED                   0x20
// RESERVED                   0x10
#define ISA_CD_FLAG           0x08
#define ISA_SMS_MSG_FLAG      0x04
#define ISA_IBF_FLAG          0x02
#define ISA_OBF_FLAG          0x01
//
// ISA interface register access defines
//
#define ISA_OBF(a)            ((BYTE)(_inp(a+1) & ISA_OBF_FLAG))
#define ISA_IBF(a)            ((BYTE)(_inp(a+1) & ISA_IBF_FLAG))
#define ISA_MSG(a)            ((BYTE)(_inp(a+1) & ISA_SMS_MSG_FLAG))
#define ISA_STATE(a)          ((BYTE)(_inp(a+1) & ISA_STATE_MASK))
#define ISA_STATUS(a)         ((BYTE)(_inp(a+1)))
#define ISA_READ_BMC_DATA(a)  ((BYTE)(_inp(a)))
#define ISA_WRITE_BMC_DATA(a,x)    (_outp(a,(unsigned)x))
#define ISA_WRITE_BMC_CMD(a,x)     (_outp(a+1,(unsigned)x))
//
// SMS Transfer Stream Control Codes
//                                
#define ISA_GET_STATUS_ABORT   0x60
#define ISA_WRITE_START        0x61
#define ISA_WRITE_END          0X62
#define ISA_READ               0X68

#define BMC_SLAVE_ADDR         0x20
#define MAX_ISA_LENGTH         35

#define ISA_SMS_TIMEOUT        5000    //    in miliseconds - 1 second
#define ISA_SMM_TIMEOUT        100     //    in microseconds
//
// mBMC Address
//
extern int mBMCAddr;

static BOOL
SmsBufferAvail( void *context);

static IMB_STATUS
SendBmcRequest (
        BmcRequest *    request,
        DWORD           reqLength,
        BmcResponse *   response,
        DWORD *         respLength,
        void *          context,
        DWORD           ipmiOldFlag
        );

static int 
ReadResponse(
        BmcResponse *   resp, 
        SMBCharStruct * smbChar,
        void *          context
        );  
static int 
SendRequest(
        BmcRequest *    req, 
        int             length, 
        SMBCharStruct * smbChar, 
        void *          context
        );
//
// amd read and write functions
//
int amd_ec_wait_write( WORD baseAddress );
int amd_ec_wait_read( WORD baseAddress );
int amd_ec_read(WORD baseAddress, BYTE address, BYTE *data);
int amd_ec_write(WORD baseAddress, BYTE address, BYTE data);



